/**
 * Fuse.js v5.2.0-alpha.5 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
var e,t;e=this,t=function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function r(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}function n(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function i(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function o(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?i(Object(r),!0).forEach((function(t){n(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):i(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var a=function(e){return Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)},s=function(e){return"string"==typeof e},h=function(e){return"number"==typeof e},c=function(e){return null!=e};function l(e,t){var r=[],n=!1;return function e(t,i){if(i){var o=i.indexOf("."),l=i,u=null;-1!==o&&(l=i.slice(0,o),u=i.slice(o+1));var f=t[l];if(c(f))if(u||!s(f)&&!h(f))if(a(f)){n=!0;for(var v=0,d=f.length;v<d;v+=1)e(f[v],u)}else u&&e(f,u);else r.push(function(e){return null==e?"":function(e){if("string"==typeof e)return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}(e)}(f))}else r.push(t)}(e,t),n?r:r[0]}var u=o({},{isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:function(e,t){return e.score-t.score}},{},{includeMatches:!1,findAllMatches:!1,minMatchCharLength:1},{},{location:0,threshold:.6,distance:100},{},{useExtendedSearch:!1,getFn:l});function f(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=t.errors,n=void 0===r?0:r,i=t.currentLocation,o=void 0===i?0:i,a=t.expectedLocation,s=void 0===a?0:a,h=t.distance,c=void 0===h?u.distance:h,l=n/e.length,f=Math.abs(s-o);return c?l+f/c:f?1:l}function v(){for(var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:u.minMatchCharLength,r=[],n=-1,i=-1,o=0,a=e.length;o<a;o+=1){var s=e[o];s&&-1===n?n=o:s||-1===n||((i=o-1)-n+1>=t&&r.push([n,i]),n=-1)}return e[o-1]&&o-n>=t&&r.push([n,o-1]),r}function d(e){for(var t={},r=e.length,n=0;n<r;n+=1)t[e.charAt(n)]=0;for(var i=0;i<r;i+=1)t[e.charAt(i)]|=1<<r-i-1;return t}var g=function(){function t(r){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=n.location,o=void 0===i?u.location:i,a=n.threshold,s=void 0===a?u.threshold:a,h=n.distance,c=void 0===h?u.distance:h,l=n.includeMatches,f=void 0===l?u.includeMatches:l,v=n.findAllMatches,g=void 0===v?u.findAllMatches:v,p=n.minMatchCharLength,y=void 0===p?u.minMatchCharLength:p,m=n.isCaseSensitive,k=void 0===m?u.isCaseSensitive:m;if(e(this,t),this.options={location:o,threshold:s,distance:c,includeMatches:f,findAllMatches:g,minMatchCharLength:y,isCaseSensitive:k},r.length>32)throw new Error("Pattern length exceeds max of ".concat(32,"."));this.pattern=k?r:r.toLowerCase(),this.patternAlphabet=d(this.pattern)}return r(t,[{key:"searchIn",value:function(e){var t=e.$;return this.searchInString(t)}},{key:"searchInString",value:function(e){var t=this.options,r=t.isCaseSensitive,n=t.includeMatches;if(r||(e=e.toLowerCase()),this.pattern===e){var i={isMatch:!0,score:0};return n&&(i.matchedIndices=[[0,e.length-1]]),i}var o=this.options,a=o.location,s=o.distance,h=o.threshold,c=o.findAllMatches,l=o.minMatchCharLength;return function(e,t,r){var n,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=i.location,a=void 0===o?u.location:o,s=i.distance,h=void 0===s?u.distance:s,c=i.threshold,l=void 0===c?u.threshold:c,d=i.findAllMatches,g=void 0===d?u.findAllMatches:d,p=i.minMatchCharLength,y=void 0===p?u.minMatchCharLength:p,m=i.includeMatches,k=void 0===m?u.includeMatches:m,M=t.length,b=e.length,x=Math.max(0,Math.min(a,b)),_=l,w=x,O=[];if(k)for(var S=0;S<b;S+=1)O[S]=0;for(;(n=e.indexOf(t,w))>-1;){var I=f(t,{currentLocation:n,expectedLocation:x,distance:h});if(_=Math.min(I,_),w=n+M,k)for(var L=0;L<M;)O[n+L]=1,L+=1}w=-1;for(var A=[],j=1,C=M+b,P=1<<(M<=31?M-1:30),$=0;$<M;$+=1){for(var E=0,N=C;E<N;){var F=f(t,{errors:$,currentLocation:x+N,expectedLocation:x,distance:h});F<=_?E=N:C=N,N=Math.floor((C-E)/2+E)}C=N;var D=Math.max(1,x-N+1),J=g?b:Math.min(x+N,b)+M,K=Array(J+2);K[J+1]=(1<<$)-1;for(var U=J;U>=D;U-=1){var q=U-1,T=r[e.charAt(q)];if(T&&k&&(O[q]=1),K[U]=(K[U+1]<<1|1)&T,0!==$&&(K[U]|=(A[U+1]|A[U])<<1|1|A[U+1]),K[U]&P&&(j=f(t,{errors:$,currentLocation:q,expectedLocation:x,distance:h}))<=_){if(_=j,(w=q)<=x)break;D=Math.max(1,2*x-w)}}var z=f(t,{errors:$+1,currentLocation:x,expectedLocation:x,distance:h});if(z>_)break;A=K}var B={isMatch:w>=0,score:j||.001};return k&&(B.matchedIndices=v(O,y)),B}(e,this.pattern,this.patternAlphabet,{location:a,distance:s,threshold:h,findAllMatches:c,minMatchCharLength:l,includeMatches:n})}}]),t}();function p(e,t){var r=t.n,n=void 0===r?3:r,i=t.pad,o=void 0===i||i,a=t.sort,s=void 0!==a&&a,h=[];if(null==e)return h;e=e.toLowerCase(),o&&(e=" ".concat(e," "));var c=e.length-n+1;if(c<1)return h;for(;c--;)h[c]=e.substr(c,n);return s&&h.sort((function(e,t){return e==t?0:e<t?-1:1})),h}var y=/[^ ]+/g;function m(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=r.getFn,i=void 0===n?l:n,o=r.ngrams,h=void 0!==o&&o,u=[];if(s(t[0]))for(var f=0,v=t.length;f<v;f+=1){var d=t[f];if(c(d)){var g={$:d,idx:f,t:d.match(y).length};h&&(g.ng=p(d,{sort:!0})),u.push(g)}}else for(var m=e.length,k=0,M=t.length;k<M;k+=1){for(var b=t[k],x={idx:k,$:{}},_=0;_<m;_+=1){var w=e[_],O=i(b,w);if(c(O))if(a(O)){for(var S=[],I=[{arrayIndex:-1,value:O}];I.length;){var L=I.pop(),A=L.arrayIndex,j=L.value;if(c(j))if(s(j)){var C={$:j,idx:A,t:j.match(y).length};h&&(C.ng=p(j,{sort:!0})),S.push(C)}else if(a(j))for(var P=0,$=j.length;P<$;P+=1)I.push({arrayIndex:P,value:j[P]})}x.$[w]=S}else{var E={$:O,t:O.match(y).length};h&&(E.ng=p(O,{sort:!0})),x.$[w]=E}}u.push(x)}return u}var k=function(){function t(r){if(e(this,t),this._keys={},this._keyNames=[],this._length=r.length,r.length&&s(r[0]))for(var n=0;n<this._length;n+=1){var i=r[n];this._keys[i]={weight:1},this._keyNames.push(i)}else{for(var o=0,a=0;a<this._length;a+=1){var h=r[a];if(!Object.prototype.hasOwnProperty.call(h,"name"))throw new Error('Missing "name" property in key object');var c=h.name;if(this._keyNames.push(c),!Object.prototype.hasOwnProperty.call(h,"weight"))throw new Error('Missing "weight" property in key object');var l=h.weight;if(l<=0||l>=1)throw new Error('"weight" property in key must be in the range of (0, 1)');this._keys[c]={weight:l},o+=l}for(var u=0;u<this._length;u+=1){var f=this._keyNames[u],v=this._keys[f].weight;this._keys[f].weight=v/o}}}return r(t,[{key:"get",value:function(e,t){return this._keys[e]?this._keys[e][t]:-1}},{key:"keys",value:function(){return this._keyNames}},{key:"count",value:function(){return this._length}},{key:"toJSON",value:function(){return JSON.stringify(this._keys)}}]),t}();function M(e,t){var r=e.matches;if(t.matches=[],c(r))for(var n=0,i=r.length;n<i;n+=1){var o=r[n];if(c(o.indices)&&0!==o.indices.length){var a={indices:o.indices,value:o.value};o.key&&(a.key=o.key),o.idx>-1&&(a.refIndex=o.idx),t.matches.push(a)}}}function b(e,t){t.score=e.score}var x=[],_=function(){function t(r){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;e(this,t),this.options=o({},u,{},n),this._processKeys(this.options.keys),this.setCollection(r,i)}return r(t,[{key:"setCollection",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this.list=e,this.listIsStringArray=s(e[0]),t?this.setIndex(t):this.setIndex(this._createIndex())}},{key:"setIndex",value:function(e){this._indexedList=e}},{key:"_processKeys",value:function(e){this._keyStore=new k(e)}},{key:"_createIndex",value:function(){return m(this._keyStore.keys(),this.list,{getFn:this.options.getFn})}},{key:"search",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{limit:!1};if(!(e=e.trim()).length)return[];for(var r=this.options.shouldSort,n=null,i=0,o=x.length;i<o;i+=1){var a=x[i];if(a.condition(e,this.options)){n=new a(e,this.options);break}}n||(n=new g(e,this.options));var s=this._searchUsing(n);return this._computeScore(s),r&&this._sort(s),t.limit&&h(t.limit)&&(s=s.slice(0,t.limit)),this._format(s)}},{key:"_searchUsing",value:function(e){var t=this._indexedList,r=[],n=this.options.includeMatches;if(this.listIsStringArray)for(var i=0,o=t.length;i<o;i+=1){var s=t[i],h=s.$,l=s.idx,u=s.t;if(c(h)){var f=e.searchIn(s),v=f.isMatch,d=f.score;if(v){var g={score:d,value:h,t:u};n&&(g.indices=f.matchedIndices),r.push({item:h,idx:l,matches:[g]})}}}else for(var p=this._keyStore.keys(),y=this._keyStore.count(),m=0,k=t.length;m<k;m+=1){var M=t[m],b=M.$,x=M.idx;if(c(b)){for(var _=[],w=0;w<y;w+=1){var O=p[w],S=b[O];if(c(S))if(a(S))for(var I=0,L=S.length;I<L;I+=1){var A=S[I],j=A.$,C=A.idx,P=A.t;if(c(j)){var $=e.searchIn(A),E=$.isMatch,N=$.score;if(E){var F={score:N,key:O,value:j,idx:C,t:P};n&&(F.indices=$.matchedIndices),_.push(F)}}}else{var D=S.$,J=S.t,K=e.searchIn(S),U=K.isMatch,q=K.score;if(!U)continue;var T={score:q,key:O,value:D,t:J};n&&(T.indices=K.matchedIndices),_.push(T)}}_.length&&r.push({idx:x,item:b,matches:_})}}return r}},{key:"_computeScore",value:function(e){for(var t=e.length,r=0;r<t;r+=1){for(var n=e[r],i=n.matches,o=i.length,a=1,s=0;s<o;s+=1){var h=i[s],c=h.key,l=h.t,u=this._keyStore.get(c,"weight"),f=u>-1?u:1,v=0===h.score&&u>-1?Number.EPSILON:h.score,d=1/Math.sqrt(l);a*=Math.pow(v,f*d)}n.score=a}}},{key:"_sort",value:function(e){e.sort(this.options.sortFn)}},{key:"_format",value:function(e){var t=[],r=this.options,n=r.includeMatches,i=r.includeScore,o=[];n&&o.push(M),i&&o.push(b);for(var a=0,s=e.length;a<s;a+=1){var h=e[a],c=h.idx,l={item:this.list[c],refIndex:c};if(o.length)for(var u=0,f=o.length;u<f;u+=1)o[u](h,l);t.push(l)}return t}}]),t}();return _.version="5.2.0-alpha.5",_.createIndex=m,_.config=u,_},"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Fuse=t();